<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWarningType1 ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfWarningType1 extends AbstractStructArrayBase
{
    /**
     * The Warning
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgWarningType[]
     */
    public $Warning;
    /**
     * Constructor method for ArrayOfWarningType1
     * @uses DgArrayOfWarningType1::setWarning()
     * @param \dgsoft\StructType\DgWarningType[] $warning
     */
    public function __construct(array $warning = array())
    {
        $this
            ->setWarning($warning);
    }
    /**
     * Get Warning value
     * @return \dgsoft\StructType\DgWarningType[]|null
     */
    public function getWarning()
    {
        return $this->Warning;
    }
    /**
     * Set Warning value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgWarningType[] $warning
     * @return \dgsoft\ArrayType\DgArrayOfWarningType1
     */
    public function setWarning(array $warning = array())
    {
        foreach ($warning as $arrayOfWarningType1WarningItem) {
            // validation for constraint: itemType
            if (!$arrayOfWarningType1WarningItem instanceof \dgsoft\StructType\DgWarningType) {
                throw new \InvalidArgumentException(sprintf('The Warning property can only contain items of \dgsoft\StructType\DgWarningType, "%s" given', is_object($arrayOfWarningType1WarningItem) ? get_class($arrayOfWarningType1WarningItem) : gettype($arrayOfWarningType1WarningItem)), __LINE__);
            }
        }
        $this->Warning = $warning;
        return $this;
    }
    /**
     * Add item to Warning value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgWarningType $item
     * @return \dgsoft\ArrayType\DgArrayOfWarningType1
     */
    public function addToWarning(\dgsoft\StructType\DgWarningType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgWarningType) {
            throw new \InvalidArgumentException(sprintf('The Warning property can only contain items of \dgsoft\StructType\DgWarningType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Warning[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgWarningType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgWarningType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgWarningType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgWarningType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgWarningType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Warning
     */
    public function getAttributeName()
    {
        return 'Warning';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfWarningType1
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
